  MEMBER('Maillist.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
MAILLBC0:DctInit    PROCEDURE
MAILLBC0:DctKill    PROCEDURE
MAILLBC0:FilesInit  PROCEDURE
  END

Hide:Access:People   CLASS(FileManager)
Init                   PROCEDURE
BindFields             PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
PrimeFields            PROCEDURE(),PROC,DERIVED
ValidateFieldServer    PROCEDURE(UNSIGNED Id,BYTE HandleErrors),BYTE,PROC,DERIVED
                     END


Hide:Relate:People   CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:EXPORT   CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
PrimeFields            PROCEDURE(),PROC,DERIVED
                     END


Hide:Relate:EXPORT   CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Mailers  CLASS(FileManager)
Init                   PROCEDURE
BindFields             PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:Mailers  CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:MailPeople CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
PrimeFields            PROCEDURE(),PROC,DERIVED
                     END


Hide:Relate:MailPeople CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:PeopleKeys CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
ValidateFieldServer    PROCEDURE(UNSIGNED Id,BYTE HandleErrors),BYTE,PROC,DERIVED
                     END


Hide:Relate:PeopleKeys CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:KeyWords CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:KeyWords CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:STATES   CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:STATES   CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

MAILLBC0:DctInit PROCEDURE
  CODE
  Relate:People &= Hide:Relate:People
  Relate:EXPORT &= Hide:Relate:EXPORT
  Relate:Mailers &= Hide:Relate:Mailers
  Relate:MailPeople &= Hide:Relate:MailPeople
  Relate:PeopleKeys &= Hide:Relate:PeopleKeys
  Relate:KeyWords &= Hide:Relate:KeyWords
  Relate:STATES &= Hide:Relate:STATES

MAILLBC0:FilesInit PROCEDURE
  CODE
  Hide:Relate:People.Init
  Hide:Relate:EXPORT.Init
  Hide:Relate:Mailers.Init
  Hide:Relate:MailPeople.Init
  Hide:Relate:PeopleKeys.Init
  Hide:Relate:KeyWords.Init
  Hide:Relate:STATES.Init


MAILLBC0:DctKill PROCEDURE
  CODE
  Hide:Relate:People.Kill
  Hide:Relate:EXPORT.Kill
  Hide:Relate:Mailers.Kill
  Hide:Relate:MailPeople.Kill
  Hide:Relate:PeopleKeys.Kill
  Hide:Relate:KeyWords.Kill
  Hide:Relate:STATES.Kill


Hide:Access:People.Init PROCEDURE
  CODE
  SELF.Init(People,GlobalErrors)
  SELF.Buffer &= PEO:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(PEO:CustomerNumberKey,'Primary key - by CustomerNumber',1)
  SELF.AddKey(PEO:LastNameKey,'Sort key - by LastName',0)
  SELF.AddKey(PEO:StateKey,'Sort key - by State and City',0)
  Access:People &= SELF


Hide:Relate:People.Init PROCEDURE
  CODE
  Hide:Access:People.Init
  SELF.Init(Access:People,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:STATES)
  SELF.AddRelation(Relate:PeopleKeys,RI:CASCADE,RI:RESTRICT,PKW:IDNumberKey)
  SELF.AddRelationLink(PEO:IDNumber,PKW:IDNumber)
  SELF.AddRelation(Relate:MailPeople,RI:CASCADE,RI:RESTRICT,MAP:CustomerNumberKey)
  SELF.AddRelationLink(PEO:IDNumber,MAP:IDNumber)


Hide:Access:People.BindFields PROCEDURE

  CODE
  PARENT.BindFields
  BIND('PEO:Notes',PEO:Notes)


Hide:Access:People.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:People &= NULL


Hide:Access:People.PrimeFields PROCEDURE

  CODE
  PEO:Salutation = 'Mr.'
  PEO:NameSuffix = ' '
  PARENT.PrimeFields


Hide:Access:People.ValidateFieldServer PROCEDURE(UNSIGNED Id,BYTE HandleErrors)

ReturnValue          BYTE,AUTO

Save:STATES10      USHORT,AUTO
  CODE
  ReturnValue = PARENT.ValidateFieldServer(Id,HandleErrors)
  CASE Id
  OF 10
    GlobalErrors.SetField('Person''s State')
    Save:STATES10 = Access:STATES.SaveFile()
    STA:CODE = PEO:State
    ReturnValue = Access:STATES.TryFetch(STA:STATEKEY)
    IF ReturnValue <> Level:Benign
      IF HandleErrors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'STATES')
      END
    END
    Access:STATES.RestoreFile(Save:STATES10)
  END
  RETURN ReturnValue


Hide:Relate:People.Kill PROCEDURE

  CODE
  Hide:Access:People.Kill
  PARENT.Kill
  Relate:People &= NULL


Hide:Access:EXPORT.Init PROCEDURE
  CODE
  SELF.Init(EXPORT,GlobalErrors)
  SELF.Buffer &= EXP:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  Access:EXPORT &= SELF


Hide:Relate:EXPORT.Init PROCEDURE
  CODE
  Hide:Access:EXPORT.Init
  SELF.Init(Access:EXPORT,1)


Hide:Access:EXPORT.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:EXPORT &= NULL


Hide:Access:EXPORT.PrimeFields PROCEDURE

  CODE
  EXP:Salutation = 'Mr.'
  EXP:NameSuffix = ' '
  PARENT.PrimeFields


Hide:Relate:EXPORT.Kill PROCEDURE

  CODE
  Hide:Access:EXPORT.Kill
  PARENT.Kill
  Relate:EXPORT &= NULL


Hide:Access:Mailers.Init PROCEDURE
  CODE
  SELF.Init(Mailers,GlobalErrors)
  SELF.Buffer &= MAI:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(MAI:MailerNumberKey,'Primary key - by MailerNumber',1)
  SELF.AddKey(MAI:DescriptionKey,'Sort key - by Description',0)
  Access:Mailers &= SELF


Hide:Relate:Mailers.Init PROCEDURE
  CODE
  Hide:Access:Mailers.Init
  SELF.Init(Access:Mailers,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:MailPeople,RI:CASCADE,RI:RESTRICT,MAP:MailerNumberKey)
  SELF.AddRelationLink(MAI:MailerNumber,MAP:MailerNumber)


Hide:Access:Mailers.BindFields PROCEDURE

  CODE
  PARENT.BindFields
  BIND('MAI:MailerNotes',MAI:MailerNotes)


Hide:Access:Mailers.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Mailers &= NULL


Hide:Relate:Mailers.Kill PROCEDURE

  CODE
  Hide:Access:Mailers.Kill
  PARENT.Kill
  Relate:Mailers &= NULL


Hide:Access:MailPeople.Init PROCEDURE
  CODE
  SELF.Init(MailPeople,GlobalErrors)
  SELF.Buffer &= MAP:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(MAP:CustomerMailerKey,'Primary key - by Customer & Mailer Num.',0)
  SELF.AddKey(MAP:CustomerNumberKey,'Sort key - by CustomerNumber',0)
  SELF.AddKey(MAP:MailerNumberKey,'Sort key - by MailerNumber',0)
  Access:MailPeople &= SELF


Hide:Relate:MailPeople.Init PROCEDURE
  CODE
  Hide:Access:MailPeople.Init
  SELF.Init(Access:MailPeople,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Mailers)
  SELF.AddRelation(Relate:People)


Hide:Access:MailPeople.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:MailPeople &= NULL


Hide:Access:MailPeople.PrimeFields PROCEDURE

  CODE
  MAP:Status = 'Active'
  PARENT.PrimeFields


Hide:Relate:MailPeople.Kill PROCEDURE

  CODE
  Hide:Access:MailPeople.Kill
  PARENT.Kill
  Relate:MailPeople &= NULL


Hide:Access:PeopleKeys.Init PROCEDURE
  CODE
  SELF.Init(PeopleKeys,GlobalErrors)
  SELF.Buffer &= PKW:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(PKW:IDKeyWordKey,'Primary key - by ID & Keyword',0)
  SELF.AddKey(PKW:KeyWordDescriptionKey,'Sort key - by Description',0)
  SELF.AddKey(PKW:IDNumberKey,'PKW:IDNumberKey',0)
  SELF.AddKey(PKW:KeyWordNumberKey,'PKW:KeyWordNumberKey',0)
  Access:PeopleKeys &= SELF


Hide:Relate:PeopleKeys.Init PROCEDURE
  CODE
  Hide:Access:PeopleKeys.Init
  SELF.Init(Access:PeopleKeys,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:KeyWords)
  SELF.AddRelation(Relate:People)


Hide:Access:PeopleKeys.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:PeopleKeys &= NULL


Hide:Access:PeopleKeys.ValidateFieldServer PROCEDURE(UNSIGNED Id,BYTE HandleErrors)

ReturnValue          BYTE,AUTO

Save:People1       USHORT,AUTO
Save:KeyWords2     USHORT,AUTO
  CODE
  ReturnValue = PARENT.ValidateFieldServer(Id,HandleErrors)
  CASE Id
  OF 1
    GlobalErrors.SetField('Number to identify person')
    Save:People1 = Access:People.SaveFile()
    PEO:IDNumber = PKW:IDNumber
    ReturnValue = Access:People.TryFetch(PEO:CustomerNumberKey)
    IF ReturnValue <> Level:Benign
      IF HandleErrors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'People')
      END
    END
    Access:People.RestoreFile(Save:People1)
  OF 2
    GlobalErrors.SetField('Keyword number to indentify keyword')
    Save:KeyWords2 = Access:KeyWords.SaveFile()
    KEY:KeyWordNumber = PKW:KeyWordNumber
    ReturnValue = Access:KeyWords.TryFetch(KEY:KeyWordNumberKey)
    IF ReturnValue <> Level:Benign
      IF HandleErrors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'KeyWords')
      END
    END
    Access:KeyWords.RestoreFile(Save:KeyWords2)
  END
  RETURN ReturnValue


Hide:Relate:PeopleKeys.Kill PROCEDURE

  CODE
  Hide:Access:PeopleKeys.Kill
  PARENT.Kill
  Relate:PeopleKeys &= NULL


Hide:Access:KeyWords.Init PROCEDURE
  CODE
  SELF.Init(KeyWords,GlobalErrors)
  SELF.Buffer &= KEY:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(KEY:KeyWordNumberKey,'Primary key - by KeywordNumber',1)
  SELF.AddKey(KEY:KeyWordDescriptionKey,'Sort key - by Description',0)
  Access:KeyWords &= SELF


Hide:Relate:KeyWords.Init PROCEDURE
  CODE
  Hide:Access:KeyWords.Init
  SELF.Init(Access:KeyWords,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:PeopleKeys,RI:CASCADE,RI:RESTRICT,PKW:KeyWordNumberKey)
  SELF.AddRelationLink(KEY:KeyWordNumber,PKW:KeyWordNumber)


Hide:Access:KeyWords.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:KeyWords &= NULL


Hide:Relate:KeyWords.Kill PROCEDURE

  CODE
  Hide:Access:KeyWords.Kill
  PARENT.Kill
  Relate:KeyWords &= NULL


Hide:Access:STATES.Init PROCEDURE
  CODE
  SELF.Init(STATES,GlobalErrors)
  SELF.Buffer &= STA:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(STA:STATEKEY,'STA:STATEKEY',0)
  Access:STATES &= SELF


Hide:Relate:STATES.Init PROCEDURE
  CODE
  Hide:Access:STATES.Init
  SELF.Init(Access:STATES,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:People,RI:CASCADE,RI:RESTRICT,PEO:StateKey)
  SELF.AddRelationLink(STA:CODE,PEO:State)


Hide:Access:STATES.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:STATES &= NULL


Hide:Relate:STATES.Kill PROCEDURE

  CODE
  Hide:Access:STATES.Kill
  PARENT.Kill
  Relate:STATES &= NULL

